# Zig Bloxel Game

This is a small project attempting to create a "bloxel" game (think Minecraft) using the relatively new [Zig] programming language with the help of [Mach], [Flecs] and [zig-gamedev]. Due to Zig being a quickly evolving language, Mach and zig-gamedev, and as a result this project, target version `0.12.0-dev.3180+83e578a18` (aka `2024.3.0-mach`) of Zig. Consider using [zigup] to manage multiple compiler versions.

With this project I'm learning new things and adding functionality step by step, then documenting my knowledge with lots of comments. Each substantial commit to this repository should cover a manageable chunk of changes, which ideally anyone interested should be able to follow along with. Hopefully this can act as a resource for people trying to learn something about game development with Zig and the other tools used here.

[Zig]:         https://ziglang.org/
[Mach]:        https://github.com/hexops/mach-core
[Flecs]:       https://github.com/SanderMertens/flecs
[zig-gamedev]: https://github.com/zig-gamedev/zig-gamedev
[zigup]:       https://github.com/marler8997/zigup

## Dependencies

```sh
mkdir -p libs
cd libs

# Clone zig-gamedev sparsely, only grabbing top-level files.
git clone --sparse --filter=blob:none https://github.com/zig-gamedev/zig-gamedev.git
# However, we also care about zmath, so check that out too.
git -C zig-gamedev sparse-checkout add libs/zmath

git clone https://git.mcft.net/copygirl/flecs-zig-ble.git
```
